VERSION 5.00
Begin VB.Form frmScalingComparo 
   Caption         =   "Picture Scaling Method Comparisons"
   ClientHeight    =   6690
   ClientLeft      =   90
   ClientTop       =   420
   ClientWidth     =   9420
   ClipControls    =   0   'False
   KeyPreview      =   -1  'True
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   446
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   628
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox PB3 
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      Enabled         =   0   'False
      Height          =   3345
      Left            =   4725
      ScaleHeight     =   223
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   314
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   3360
      Width           =   4710
   End
   Begin VB.PictureBox PB2 
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      Enabled         =   0   'False
      Height          =   3345
      Left            =   0
      ScaleHeight     =   223
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   314
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   3360
      Width           =   4710
   End
   Begin VB.PictureBox PB1 
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      Enabled         =   0   'False
      Height          =   3345
      Left            =   4725
      ScaleHeight     =   223
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   314
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   4710
   End
   Begin VB.Image Img 
      Enabled         =   0   'False
      Height          =   3345
      Left            =   0
      Stretch         =   -1  'True
      Top             =   0
      Width           =   4710
   End
End
Attribute VB_Name = "frmScalingComparo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'#Const USE_MEMORY_DC = True '<-- Supposedly faster, but consumes more memory

Private Const ERROR_INVALID_PARAMETER As Long = 87

Private Enum StretchBltModes
    [_BLACKONWHITE] = 1
    [_WHITEONBLACK] = 2
    [_COLORONCOLOR] = 3
    [_HALFTONE] = 4
    [_MAXSTRETCHBLTMODE] = 4

   'New StretchBlt() Modes
    STRETCH_ANDSCANS = [_BLACKONWHITE]
    STRETCH_ORSCANS = [_WHITEONBLACK]
    STRETCH_DELETESCANS = [_COLORONCOLOR]
    STRETCH_HALFTONE = [_HALFTONE]
End Enum
#If False Then
    Dim STRETCH_ANDSCANS, STRETCH_ORSCANS, STRETCH_DELETESCANS, STRETCH_HALFTONE
    Dim [_BLACKONWHITE], [_WHITEONBLACK], [_COLORONCOLOR], [_HALFTONE], [_MAXSTRETCHBLTMODE]
#End If

Private Declare Function SetStretchBltMode Lib "gdi32.dll" (ByVal hDC As Long, ByVal iStretchMode As StretchBltModes) As StretchBltModes

#If USE_MEMORY_DC Then

Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hDC As Long) As Long 'BOOL
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hgdiobj As Long) As Long
Private Declare Function StretchBlt Lib "gdi32.dll" (ByVal hdcDest As Long, ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal nHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, ByVal dwRop As RasterOpConstants) As Long 'BOOL

#Else

Private Const DIB_RGB_COLORS As Long = 0
Private Const GDI_ERROR      As Long = &HFFFFFFFF

Private Type BITMAP
    bmType       As Long
    bmWidth      As Long
    bmHeight     As Long
    bmWidthBytes As Long
    bmPlanes     As Integer
    bmBitsPixel  As Integer
    bmBits       As Long
End Type

Private Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
End Type

Private Type RGBQUAD
    rgbBlue     As Byte
    rgbGreen    As Byte
    rgbRed      As Byte
    rgbReserved As Byte
End Type

Private Type BITMAPINFO
    bmiHeader         As BITMAPINFOHEADER
   'bmiColors(1 To 1) As RGBQUAD
End Type

Private Type DIBSECTION
    dsBm                As BITMAP
    dsBmih              As BITMAPINFOHEADER
    dsBitfields(1 To 3) As Long
    dshSection          As Long
    dsOffset            As Long
End Type

Private Declare Function GetObjectW Lib "gdi32.dll" (ByVal hgdiobj As Long, ByVal cbBuffer As Long, ByRef lpvObject As Any) As Long
Private Declare Function StretchDIBits Lib "gdi32.dll" (ByVal hDC As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal nDestWidth As Long, ByVal nDestHeight As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal lpBits As Long, ByRef lpBitsInfo As BITMAPINFO, ByVal iUsage As Long, ByVal dwRop As RasterOpConstants) As Long

#End If

#If USE_MEMORY_DC Then

Private m_hdcPB3  As Long
Private m_hbmOrig As Long

#Else

Private m_pBits   As Long
Private m_BI      As BITMAPINFO

#End If

Private m_oPic    As StdPicture

Private Sub Form_Activate()
    Form_Resize
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyEscape Then Unload Me
End Sub

Private Sub Form_Load()
    Dim sFile As String

    sFile = App.Path & "\"
    sFile = sFile & Dir(sFile & "*.jpg")

    On Error GoTo 1
    Set m_oPic = LoadPicture(sFile)
    On Error GoTo 0

    #If USE_MEMORY_DC Then
        On Error GoTo 1
        Set Picture = LoadPicture(sFile)
        On Error GoTo 0
        Set Img = Picture

        m_hdcPB3 = CreateCompatibleDC(PB3.hDC):     Debug.Assert m_hdcPB3
        m_hbmOrig = SelectObject(m_hdcPB3, m_oPic): Debug.Assert m_hbmOrig
    #Else
        Dim RV As Long, DS As DIBSECTION

        Set Img = m_oPic
        RV = GetObjectW(m_oPic, LenB(DS), DS):      Debug.Assert RV = LenB(DS)
        m_pBits = DS.dsBm.bmBits
        m_BI.bmiHeader = DS.dsBmih
    #End If
1
End Sub

Private Sub Form_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim RV As Long, sFile As String

    If Data.GetFormat(vbCFFiles) Then
        sFile = Data.Files(1&)

        #If USE_MEMORY_DC Then
            Dim hbmPrev As Long
            If Not m_oPic Is Nothing Then hbmPrev = m_oPic
        #End If

        On Error GoTo 1
        Set m_oPic = LoadPicture(sFile)
        On Error GoTo 0

        #If USE_MEMORY_DC Then
            On Error GoTo 1
            Set Picture = LoadPicture(sFile)
            On Error GoTo 0
            Set Img = Picture

            If m_hdcPB3 Then
                RV = SelectObject(m_hdcPB3, m_oPic):       'Debug.Assert RV = hbmPrev
            Else
                m_hdcPB3 = CreateCompatibleDC(PB3.hDC):     Debug.Assert m_hdcPB3
                m_hbmOrig = SelectObject(m_hdcPB3, m_oPic): Debug.Assert m_hbmOrig
            End If
        #Else
            Dim DS As DIBSECTION

            Set Img = m_oPic
            RV = GetObjectW(m_oPic, LenB(DS), DS):          Debug.Assert RV = LenB(DS)
            m_pBits = DS.dsBm.bmBits
            m_BI.bmiHeader = DS.dsBmih
        #End If

        Form_Resize
        Form_Resize
1   End If
End Sub

Private Sub Form_Resize()
    Const HALF = 0.5!
    Dim RV As Long, HalfWidth As Single, HalfHeight As Single

    #If USE_MEMORY_DC Then
        If Picture.Handle = 0& Then Exit Sub
    #Else
        If m_oPic Is Nothing Then Exit Sub
    #End If

    PB1.Cls: PB2.Cls: PB3.Cls

    HalfWidth = ScaleWidth * HALF
    HalfHeight = ScaleHeight * HALF

    Img.Move ScaleLeft, ScaleTop, HalfWidth, HalfHeight
    PB1.Move HalfWidth, ScaleTop, HalfWidth, HalfHeight     'Img.Left + Img.Width, ScaleTop, HalfWidth, HalfHeight
    PB2.Move ScaleLeft, HalfHeight, HalfWidth, HalfHeight   'ScaleLeft, Img.Top + Img.Height, HalfWidth, HalfHeight
    PB3.Move HalfWidth, HalfHeight, HalfWidth, HalfHeight   'Img.Left + Img.Width, Img.Top + Img.Height, HalfWidth, HalfHeight

    With PB1
        .AutoRedraw = True
        #If USE_MEMORY_DC Then
            .PaintPicture Picture, .ScaleLeft, .ScaleTop, .ScaleWidth, .ScaleHeight
        #Else
            .PaintPicture m_oPic, .ScaleLeft, .ScaleTop, .ScaleWidth, .ScaleHeight
        #End If
        .AutoRedraw = False
    End With

    With PB2
        .AutoRedraw = True
        #If USE_MEMORY_DC Then
            Picture.Render .hDC, .ScaleLeft, .ScaleTop, .ScaleWidth, .ScaleHeight, 0&, Picture.Height, Picture.Width, -Picture.Height, ByVal 0&
        #Else
            m_oPic.Render .hDC, .ScaleLeft, .ScaleTop, .ScaleWidth, .ScaleHeight, 0&, m_oPic.Height, m_oPic.Width, -m_oPic.Height, ByVal 0&
        #End If
        .AutoRedraw = False
    End With

    With PB3
        .AutoRedraw = True
         RV = SetStretchBltMode(.hDC, STRETCH_HALFTONE): Debug.Assert RV <> 0& And RV <> ERROR_INVALID_PARAMETER

        #If USE_MEMORY_DC Then
            RV = StretchBlt(.hDC, .ScaleLeft, .ScaleTop, .ScaleWidth, .ScaleHeight, _
                             m_hdcPB3, 0&, 0&, .ScaleX(m_oPic.Width, vbHimetric, vbPixels), _
                            .ScaleY(m_oPic.Height, vbHimetric, vbPixels), vbSrcCopy): Debug.Assert RV
        #Else
            RV = StretchDIBits(.hDC, .ScaleLeft, .ScaleTop, .ScaleWidth, .ScaleHeight, _
                                0&, 0&, .ScaleX(m_oPic.Width, vbHimetric, vbPixels), _
                               .ScaleY(m_oPic.Height, vbHimetric, vbPixels), _
                                m_pBits, m_BI, DIB_RGB_COLORS, vbSrcCopy): Debug.Assert RV <> 0& And RV <> GDI_ERROR
        #End If

        .AutoRedraw = False
    End With

    Caption = App.Title & " [" & _
              FormatNumber(m_oPic.Width / m_oPic.Height, 3&) & ": " & _
              FormatNumber(Img.Width / Img.Height, 3&) & " " & _
              FormatNumber(PB1.ScaleWidth / PB1.ScaleHeight, 3&) & " " & _
              FormatNumber(PB2.ScaleWidth / PB2.ScaleHeight, 3&) & " " & _
              FormatNumber(PB3.ScaleWidth / PB3.ScaleHeight, 3&) & "]"
End Sub

#If USE_MEMORY_DC Then

Private Sub Form_Unload(Cancel As Integer)
    If m_hbmOrig Then m_hbmOrig = SelectObject(m_hdcPB3, m_hbmOrig): Debug.Assert m_hbmOrig
    If m_hdcPB3 Then m_hdcPB3 = DeleteDC(m_hdcPB3):                  Debug.Assert m_hdcPB3
End Sub

#End If

'DIBs and Their Use
'https://msdn.microsoft.com/en-us/library/ms969901.aspx

'Flicker-Free Displays Using an Off-Screen DC
'https://msdn.microsoft.com/en-us/library/ms969905.aspx

'GDI Objects
'https://msdn.microsoft.com/en-us/library/ms969928.aspx

'GDI Overview
'https://msdn.microsoft.com/en-us/library/ms969913.aspx
